SystemOrganization addCategory: #'Glamour-Browsers'!

GLMExplicitBrowser subclass: #GLMTableLayoutBrowser
	instanceVariableNames: 'cell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMTableLayoutBrowser methodsFor: 'layout' stamp: ' 11/3/09 10:15'!
addColumn: aBlockOrSymbol 
	 
	^self cellOrRow addColumn: aBlockOrSymbol! !

!GLMTableLayoutBrowser methodsFor: 'layout' stamp: ' 11/3/09 10:15'!
addColumn: aBlockOrSymbol span: anInteger 
	 
	^(self addColumn: aBlockOrSymbol) span: anInteger! !

!GLMTableLayoutBrowser methodsFor: 'layout' stamp: ' 11/3/09 10:15'!
addRow: aBlockOrSymbol 
	 
	^self cellOrColumn addRow: aBlockOrSymbol! !

!GLMTableLayoutBrowser methodsFor: 'layout' stamp: ' 11/3/09 10:15'!
addRow: aBlockOrSymbol span: anInteger 
	 
	^(self addRow: aBlockOrSymbol) span: anInteger! !

!GLMTableLayoutBrowser methodsFor: 'layout' stamp: ' 11/3/09 10:15'!
cell 
	 
	^cell! !

!GLMTableLayoutBrowser methodsFor: 'private' stamp: ' 11/3/09 10:15'!
cellOrColumn 
	 
	^cell ifNil: [cell := GLMCustomColumn new browser: self]! !

!GLMTableLayoutBrowser methodsFor: 'private' stamp: ' 11/3/09 10:15'!
cellOrRow 
	 
	^cell ifNil: [cell := GLMCustomRow new browser: self]! !

!GLMTableLayoutBrowser methodsFor: 'scripting-private' stamp: ' 11/3/09 10:15'!
initializeScriptingDefaults 
	 
	super initializeScriptingDefaults. 
	self cell isNil ifTrue: [self addColumn: #pane]. 
	self jumpstartTransmissions isEmpty 
		ifTrue: 
			[self 
				addJumpstart: 
					((GLMBundleTransmission new) 
						destination: (self panes first port: #entity); 
						addPresentation: GLMFlexiblePresentation new; 
						yourself)]! !

!GLMTableLayoutBrowser methodsFor: 'rendering' stamp: ' 11/3/09 10:15'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderTableLayoutBrowser: self! !

Announcement subclass: #GLMPaneAdded
	instanceVariableNames: 'pane browser position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMPaneAdded classSide methodsFor: 'instance creation' stamp: ' 11/3/09 10:15'!
pane: aPane atPosition: anInteger inBrowser: aBrowser 
	 
	^(self new) 
		pane: aPane; 
		position: anInteger; 
		browser: aBrowser; 
		yourself! !

!GLMPaneAdded methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
browser 
	 
	^browser! !

!GLMPaneAdded methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
browser: anObject 
	 
	browser := anObject! !

!GLMPaneAdded methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
pane 
	 
	^pane! !

!GLMPaneAdded methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
pane: anObject 
	 
	pane := anObject! !

!GLMPaneAdded methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
position 
	 
	^position! !

!GLMPaneAdded methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
position: anObject 
	 
	position := anObject! !

Announcement subclass: #GLMPaneRemoved
	instanceVariableNames: 'browser pane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMPaneRemoved classSide methodsFor: 'instance creation' stamp: ' 11/3/09 10:15'!
pane: aPane fromBrowser: aBrowser 
	 
	^(self new) 
		pane: aPane; 
		browser: aBrowser; 
		yourself! !

!GLMPaneRemoved methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
browser 
	 
	^browser! !

!GLMPaneRemoved methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
browser: anObject 
	 
	browser := anObject! !

!GLMPaneRemoved methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
pane 
	 
	^pane! !

!GLMPaneRemoved methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
pane: anObject 
	 
	pane := anObject! !

GLMImplicitBrowser subclass: #GLMFinder
	instanceVariableNames: 'panes presentations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMFinder methodsFor: 'private' stamp: ' 11/3/09 10:15'!
addPaneFrom: aPort 
	 
	self panes 
		addLast: 
			((GLMPane new) 
				browser: self; 
				yourself). 
	(GLMBundleTransmission new) 
		addActiveOrigin: aPort; 
		destination: (self panes last port: #entity); 
		addPresentations: (self presentations collect: [:each | each copy]); 
		transmit. 
	self 
		announce: 
			(GLMPaneAdded 
				pane: self panes last 
				atPosition: self panes size 
				inBrowser: self)! !

!GLMFinder methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
addPresentation: aPresentation 
	 
	self presentations addLast: aPresentation! !

!GLMFinder methodsFor: 'events' stamp: ' 11/3/09 10:15'!
innerPortEvent: aPortEvent 
	 
	aPortEvent portName ~= #entity 
		ifTrue: 
			["We don't want to resend the transmission, but use a new SimpleTransmission." 
			(self pane port: aPortEvent portName) value: aPortEvent value]. 
	aPortEvent port name ~= #selection 
		ifFalse: 
			[(self panes reverse copyUpTo: aPortEvent pane) 
				do: 
					[:each |  
					self panes removeLast. 
					self announce: (GLMPaneRemoved pane: each fromBrowser: self)]. 
			self addPaneFrom: aPortEvent port]! !

!GLMFinder methodsFor: 'events' stamp: ' 11/3/09 10:15'!
outerPortEvent: aPortEvent 
	 
	aPortEvent port name ~= #entity ifTrue: [^self]. 
	panes := nil. 
	self addPaneFrom: aPortEvent port! !

!GLMFinder methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
panes 
	 
	^panes ifNil: [panes := OrderedCollection new]! !

!GLMFinder methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
presentations 
	 
	^presentations ifNil: [presentations := OrderedCollection new]! !

!GLMFinder methodsFor: 'rendering' stamp: ' 11/3/09 10:15'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderFinder: self! !

GLMFinder subclass: #GLMFixedFinder
	instanceVariableNames: 'paneCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMFixedFinder methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
numberOfVisiblePanes 
	 
	^paneCount! !

!GLMFixedFinder methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
numberOfVisiblePanes: anInteger 
	 
	paneCount := anInteger! !

Object subclass: #GLMCustomCell
	instanceVariableNames: 'children span id browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMCustomCell methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
browser 
	 
	^browser! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
browser: anObject 
	 
	browser := anObject! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
children 
	 
	^children ifNil: [children := OrderedCollection new]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
children: anObject 
	 
	children := anObject! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
childrenCount 
	 
	^self children 
		inject: 0 
		into: [:sum :each | sum + each span]! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 11/3/09 10:15'!
hasId 
	 
	^id notNil! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
id 
	 
	^id ifNil: [#anonymous]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
id: anObject 
	 
	id := anObject! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 11/3/09 10:15'!
isColumn 
	 
	^false! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 11/3/09 10:15'!
isRow 
	 
	^false! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 11/3/09 10:15'!
isSplitIntoColumns 
	 
	^self children allSatisfy: [:each | each isColumn]! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 11/3/09 10:15'!
isSplitIntoRows 
	 
	^self children allSatisfy: [:each | each isRow]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
span 
	 
	^span ifNil: [span := 1]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
span: anObject 
	 
	span := anObject! !

GLMCustomCell subclass: #GLMCustomColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMCustomColumn methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
addRow: aBlockOrSymbol 
	 
	| newRow cell | 
	cell := aBlockOrSymbol isSymbol 
		ifTrue: 
			[self browser 
				addPane: 
					((GLMPane new) 
						name: aBlockOrSymbol; 
						yourself). 
			(GLMCustomRow new) 
				id: aBlockOrSymbol; 
				browser: self browser] 
		ifFalse: 
			[newRow := GLMCustomRow new browser: self browser. 
			aBlockOrSymbol value: newRow. 
			newRow]. 
	self children addLast: cell. 
	^cell! !

!GLMCustomColumn methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
addRow: aBlockOrSymbol span: anInteger 
	 
	^(self addRow: aBlockOrSymbol) span: anInteger! !

!GLMCustomColumn methodsFor: 'testing' stamp: ' 11/3/09 10:15'!
isColumn 
	 
	^true! !

GLMCustomCell subclass: #GLMCustomRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMCustomRow methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
addColumn: aBlockOrSymbol 
	 
	| newColumn cell | 
	cell := aBlockOrSymbol isSymbol 
		ifTrue: 
			[self browser 
				addPane: 
					((GLMPane new) 
						name: aBlockOrSymbol; 
						yourself). 
			(GLMCustomColumn new) 
				id: aBlockOrSymbol; 
				browser: self browser] 
		ifFalse: 
			[newColumn := GLMCustomColumn new browser: self browser. 
			aBlockOrSymbol value: newColumn. 
			newColumn]. 
	self children addLast: cell. 
	^cell! !

!GLMCustomRow methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
addColumn: aBlockOrSymbol span: anInteger 
	 
	^(self addColumn: aBlockOrSymbol) span: anInteger! !

!GLMCustomRow methodsFor: 'testing' stamp: ' 11/3/09 10:15'!
isRow 
	 
	^true! !
